﻿using System;
using System.Linq;
using System.Threading;
using Singular.Dynamics;
using Singular.Helpers;
using Singular.Managers;
using Singular.Settings;
using Styx;

using Styx.CommonBot;
using Styx.Helpers;

using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Action = Styx.TreeSharp.Action;
using System.Drawing;

namespace Singular.ClassSpecific.Hunter
{
    public class Marksman
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit Pet { get { return StyxWoW.Me.Pet; } }
        private static HunterSettings HunterSettings { get { return SingularSettings.Instance.Hunter(); } }
	const string dataFmt = "{0,34}    {1}" ;

        #region Normal Rotation

        [Behavior(BehaviorType.Pull|BehaviorType.Combat,WoWClass.Hunter,WoWSpec.HunterMarksmanship,WoWContext.Normal | WoWContext.Instances )]
        public static Composite CreateMarksmanHunterNormalPullAndCombat()
        {
            return new PrioritySelector(
                Common.CreateHunterEnsureReadyToAttackFromLongRange(),

                Spell.WaitForCastOrChannel(),

                new Decorator(

                    ret => !Spell.IsGlobalCooldown(),

                    new PrioritySelector(

                        CreateMarksmanDiagnosticOutputBehavior(),

                        Common.CreateMisdirectionBehavior(),

                        Common.CreateHunterAvoidanceBehavior(null, null),

                        Helpers.Common.CreateInterruptBehavior(),

                        Common.CreateHunterNormalCrowdControl(),

                        Spell.Cast("Tranquilizing Shot", ctx => Me.CurrentTarget.HasAura("Enraged")),

                        Spell.Buff("Concussive Shot",
                            ret => Me.CurrentTarget.CurrentTargetGuid == Me.Guid
                                && Me.CurrentTarget.Distance > Spell.MeleeRange),

                        // Defensive Stuff
                        Spell.Cast("Intimidation",
                            ret => Me.GotTarget
                                && Me.CurrentTarget.IsAlive
                                && Me.GotAlivePet
                                && (!Me.CurrentTarget.GotTarget || Me.CurrentTarget.CurrentTarget == Me)),

                        // AoE Rotation
                        new Decorator(
                            ret => Spell.UseAOE && !(Me.CurrentTarget.IsBoss() || Me.CurrentTarget.IsPlayer) && Unit.UnfriendlyUnitsNearTarget(8f).Count() >= 3,
                            new PrioritySelector(
                                ctx => Unit.NearbyUnitsInCombatWithUsOrOurStuff.Where(u => u.InLineOfSpellSight).OrderByDescending(u => (uint) u.HealthPercent).FirstOrDefault(),
                                Spell.Cast("Kill Shot", onUnit => Unit.NearbyUnfriendlyUnits.FirstOrDefault(u => u.HealthPercent < 20 && u.Distance < 40 && u.InLineOfSpellSight && Me.IsSafelyFacing(u)), req => Me.HealthPercent < 85),
                                Spell.Cast("Multi-Shot", ctx => Clusters.GetBestUnitForCluster(Unit.NearbyUnfriendlyUnits.Where(u => u.Distance < 40 && u.InLineOfSpellSight && Me.IsSafelyFacing(u)), ClusterType.Radius, 8f)),
                                Common.CreateHunterTrapBehavior("Explosive Trap", true, on => Me.CurrentTarget, req => true),
                                Common.CastSteadyShot(on => Me.CurrentTarget)
                                )
                            ),

                        // Single Target Rotation

			//-----------------------------------------------------------------------------------------------------------------------------------
			//NEW ROUTINE BY Wladimir v0.9.0
			//Routine fits the simcraft dps at target dummys
			//-----------------------------------------------------------------------------------------------------------------------------------
			
			//Simcraft and Player Settings:
			//TotH,AMoC,None,LW  other speccs have to be tested
			//Player_Skill Good
			//no_buffood
			//no_buffs
			//rapid_fire allowed
			//no_pots
			//no_explosive_traps
			
			//Thanks to:
			//no testers yet except me ;)
			
			//Debughelpers here!
			//Note: Routine will not be executed if logging -> play manually :D
			//new Action(r => Logger.Write(dataFmt,"cd:",((Me.CurrentFocus < 65) & (Me.HasAura("Rapid Fire") | Me.HasAura("34720")) ))),

			//Kill Shot has first prior
			//Notes:
			//have to recalc if there is maybe an other prior after hotfix 12.Dec.14

                        Spell.Cast("Kill Shot", ctx => Me.CurrentTarget.HealthPercent < 36),

			//Chimaera Shot should be always on CD
			//Notes:
			//TimeSpan at Aimed Shot and Steady Shot can improve intermediate calltime -> more research needed

                        Spell.Cast("Chimaera Shot"),
			
			//Barrage is not supported at this build
			//Spell.Cast("Barrage"),

			//Glaive Toss 
			//Notes:
			//needs more testing -> actualy < 3 targets more dps without

			Spell.Cast("Glaive Toss", ret => ((!Me.HasAura("Rapid Fire") & !Me.HasAura(34720))) & Unit.UnfriendlyUnitsNearTarget(8f).Count() >= 3),

			//Rapid Fire
			//has to be tested:
			// , ctx => (Me.CurrentFocus > 50)
			//maybe get a dps benefit out of this

			Spell.Buff("Rapid Fire"),

			//Aimed Shot Logic
			//Notes:
			//Used Spell ID 34720 instead of string "Thrill of the Hunt" -> Me.HasAura also return TRUE if you have the talent selected...
			//Maybe ajust the Focus levels at next build -> needs more research
			//Ajust TimeSpans -> need more research in this, actually disabled
			//Improvement: calculate the act focus gain in the next builds
			
                        Spell.Cast("Aimed Shot", ctx => ((Me.CurrentFocus > 64) & !((Spell.GetSpellCooldown("Chimaera Shot") != TimeSpan.Zero) & Spell.GetSpellCooldown("Chimaera Shot") < new TimeSpan( 0, 0, 0, 0, 000 )) & (Me.HasAura("Rapid Fire") | Me.HasAura(34720))  )),
			Spell.Cast("Aimed Shot", ctx => ((Me.CurrentFocus > 84) & !((Spell.GetSpellCooldown("Chimaera Shot") != TimeSpan.Zero) & Spell.GetSpellCooldown("Chimaera Shot") < new TimeSpan( 0, 0, 0, 0, 000 )) & (!Me.HasAura("Rapid Fire") & !Me.HasAura(34720))  )),

                        //Steady Shot Logic
			//Notes:
			//Ajust TimeSpans -> need more research in this, actually disabled
			//Improvement: calculate the act focus gain in the next builds

			Common.CastSteadyShot(on => Me.CurrentTarget, ctx => !(Me.CastingSpell != null) & ((Me.CurrentFocus < 65) & !((Spell.GetSpellCooldown("Chimaera Shot") != TimeSpan.Zero) & Spell.GetSpellCooldown("Chimaera Shot") < new TimeSpan( 0, 0, 0, 0, 000 )) & (Me.HasAura("Rapid Fire") | Me.HasAura(34720)) )),
			Common.CastSteadyShot(on => Me.CurrentTarget, ctx => !(Me.CastingSpell != null) & ((Me.CurrentFocus < 85) & !((Spell.GetSpellCooldown("Chimaera Shot") != TimeSpan.Zero) & Spell.GetSpellCooldown("Chimaera Shot") < new TimeSpan( 0, 0, 0, 0, 000 )) & (!Me.HasAura("Rapid Fire") & !Me.HasAura(34720)) ))
			//----------------------------------------------------------------------------------------------------------------------------

			// OLD Standard Singular build
                        //Spell.Cast("Kill Shot", ctx => Me.CurrentTarget.HealthPercent < 20),
                        //Spell.Cast("Chimaera Shot"),
                        //Spell.Cast("Aimed Shot", ret => Me.CurrentFocus > 60),
                        //Common.CastSteadyShot(on => Me.CurrentTarget)
                        )
                    ),

                Movement.CreateMoveToUnitBehavior( on => StyxWoW.Me.CurrentTarget, 35f, 30f)
                );
        }

        #endregion

        #region Battleground Rotation
        [Behavior(BehaviorType.Pull | BehaviorType.Combat, WoWClass.Hunter, WoWSpec.HunterMarksmanship, WoWContext.Battlegrounds)]
        public static Composite CreateMarksmanHunterPvPPullAndCombat()
        {
            return new PrioritySelector(
                Common.CreateHunterEnsureReadyToAttackFromLongRange(),

                Spell.WaitForCastOrChannel(),

                new Decorator(

                    ret => !Spell.IsGlobalCooldown(),

                    new PrioritySelector(

                        CreateMarksmanDiagnosticOutputBehavior(),

                        Common.CreateHunterAvoidanceBehavior(null, null),

                        Helpers.Common.CreateInterruptBehavior(),
                // Helpers.Common.CreateInterruptBehavior(),

                        Common.CreateHunterPvpCrowdControl(),

                        Spell.Cast("Tranquilizing Shot", ctx => Me.CurrentTarget.HasAura("Enraged")),

                        Spell.Buff("Concussive Shot",
                            ret => Me.CurrentTarget.CurrentTargetGuid == Me.Guid
                                && !Me.CurrentTarget.IsWithinMeleeRange),

                        // Defensive Stuff
                        Spell.Cast("Intimidation",
                            ret => Me.GotTarget
                                && Me.CurrentTarget.IsAlive
                                && Me.GotAlivePet
                                && (!Me.CurrentTarget.GotTarget || Me.CurrentTarget.CurrentTarget == Me)),

                        // Single Target Rotation
                        Spell.Cast("Kill Shot", ctx => Me.CurrentTarget.HealthPercent < 20),
                        Spell.Cast("Chimaera Shot"),
                        Spell.Cast("Aimed Shot", ret => Me.HasAura("Fire!")),

                        // don't use long casts in PVP
                // Spell.Cast("Aimed Shot", ret => Me.CurrentFocus > 60),
                        Common.CastSteadyShot(on => Me.CurrentTarget)
                        )
                    ),

                Movement.CreateMoveToUnitBehavior(on => StyxWoW.Me.CurrentTarget, 35f, 30f)
                );
        }

        #endregion


        private static uint _castId;
        private static int _steadyCount;
        private static bool _doubleSteadyCast;
        private static bool DoubleSteadyCast
        {
            get
            {
                if (_steadyCount > 1)
                {
                    _castId = 0;
                    _steadyCount = 0;
                    _doubleSteadyCast = false;
                    return _doubleSteadyCast;
                }
                
                return _doubleSteadyCast;
            }
            set 
            {
                if (_doubleSteadyCast && StyxWoW.Me.CurrentCastId == _castId)
                    return;

                _castId = StyxWoW.Me.CurrentCastId;
                _steadyCount++;
                _doubleSteadyCast = value;
            }
        }

        private static Composite CreateMarksmanDiagnosticOutputBehavior()
        {
            return new Decorator(
                ret => SingularSettings.Debug,
                new Throttle(1,
                    new Action(ret =>
                    {
                        string sMsg;
                        sMsg = string.Format(".... h={0:F1}%, focus={1:F1}, moving={2}, sfbuff={3}",
                            Me.HealthPercent,
                            Me.CurrentFocus,
                            Me.IsMoving,
                            Me.GetAuraTimeLeft(53224, false).TotalSeconds
                            );

                        if (!Me.GotAlivePet)
                            sMsg += ", no pet";
                        else
                            sMsg += string.Format(", peth={0:F1}%", Me.Pet.HealthPercent);

                        WoWUnit target = Me.CurrentTarget;
                        if (target != null)
                        {
                            sMsg += string.Format(
                                ", {0}, {1:F1}%, {2:F1} yds, loss={3}",
                                target.SafeName(),
                                target.HealthPercent,
                                target.Distance,
                                target.InLineOfSpellSight
                                );
                        }

                        Logger.WriteDebug(Color.LightYellow, sMsg);
                        return RunStatus.Failure;
                    })
                    )
                );
        }


    }
}
